<?php
if ( ! class_exists( 'EV_Bike_Shop_Plugin_Activation_WPElemento_Importer' ) ) {
    /**
     * EV_Bike_Shop_Plugin_Activation_WPElemento_Importer initial setup
     *
     * @since 1.6.2
     */

    class EV_Bike_Shop_Plugin_Activation_WPElemento_Importer {

        private static $ev_bike_shop_instance;
        public $ev_bike_shop_action_count;
        public $ev_bike_shop_recommended_actions;

        /** Initiator **/
        public static function get_instance() {
          if ( ! isset( self::$ev_bike_shop_instance) ) {
            self::$ev_bike_shop_instance = new self();
          }
          return self::$ev_bike_shop_instance;
        }

        /*  Constructor */
        public function __construct() {

            add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_scripts' ) );

            // ---------- wpelementoimpoter Plugin Activation -------
            add_filter( 'ev_bike_shop_recommended_plugins', array($this, 'ev_bike_shop_recommended_elemento_importer_plugins_array') );

            $ev_bike_shop_actions                   = $this->ev_bike_shop_get_recommended_actions();
            $this->ev_bike_shop_action_count        = $ev_bike_shop_actions['count'];
            $this->ev_bike_shop_recommended_actions = $ev_bike_shop_actions['actions'];

            add_action( 'wp_ajax_create_pattern_setup_builder', array( $this, 'create_pattern_setup_builder' ) );
        }

        public function ev_bike_shop_recommended_elemento_importer_plugins_array($ev_bike_shop_plugins){
            $ev_bike_shop_plugins[] = array(
                    'name'     => esc_html__('WPElemento Importer', 'ev-bike-shop'),
                    'slug'     =>  'wpelemento-importer',
                    'function' => 'WPElemento_Importer_ThemeWhizzie',
                    'desc'     => esc_html__('We highly recommend installing the WPElemento Importer plugin for importing the demo content with Elementor.', 'ev-bike-shop'),               
            );
            return $ev_bike_shop_plugins;
        }

        public function enqueue_scripts() {
            wp_enqueue_script('updates');      
            wp_register_script( 'ev-bike-shop-plugin-activation-script', esc_url(get_template_directory_uri()) . '/includes/getstart/js/plugin-activation.js', array('jquery') );
            wp_localize_script('ev-bike-shop-plugin-activation-script', 'ev_bike_shop_plugin_activate_plugin',
                array(
                    'installing' => esc_html__('Installing', 'ev-bike-shop'),
                    'activating' => esc_html__('Activating', 'ev-bike-shop'),
                    'error' => esc_html__('Error', 'ev-bike-shop'),
                    'ajax_url' => esc_url(admin_url('admin-ajax.php')),
                    'wpelementoimpoter_admin_url' => esc_url(admin_url('admin.php?page=wpelemento-importer-tgmpa-install-plugins')),
                    'addon_admin_url' => esc_url(admin_url('admin.php?page=wpelementoimporter-wizard'))
                )
            );
            wp_enqueue_script( 'ev-bike-shop-plugin-activation-script' );

        }

        // --------- Plugin Actions ---------
        public function ev_bike_shop_get_recommended_actions() {

            $ev_bike_shop_act_count  = 0;
            $ev_bike_shop_actions_todo = get_option( 'recommending_actions', array());

            $ev_bike_shop_plugins = $this->ev_bike_shop_get_recommended_plugins();

            if ($ev_bike_shop_plugins) {
                foreach ($ev_bike_shop_plugins as $ev_bike_shop_key => $ev_bike_shop_plugin) {
                    $ev_bike_shop_action = array();
                    if (!isset($ev_bike_shop_plugin['slug'])) {
                        continue;
                    }

                    $ev_bike_shop_action['id']   = 'install_' . $ev_bike_shop_plugin['slug'];
                    $ev_bike_shop_action['desc'] = '';
                    if (isset($ev_bike_shop_plugin['desc'])) {
                        $ev_bike_shop_action['desc'] = $ev_bike_shop_plugin['desc'];
                    }

                    $ev_bike_shop_action['name'] = '';
                    if (isset($ev_bike_shop_plugin['name'])) {
                        $ev_bike_shop_action['title'] = $ev_bike_shop_plugin['name'];
                    }

                    $ev_bike_shop_link_and_is_done  = $this->ev_bike_shop_get_plugin_buttion($ev_bike_shop_plugin['slug'], $ev_bike_shop_plugin['name'], $ev_bike_shop_plugin['function']);
                    $ev_bike_shop_action['link']    = $ev_bike_shop_link_and_is_done['button'];
                    $ev_bike_shop_action['is_done'] = $ev_bike_shop_link_and_is_done['done'];
                    if (!$ev_bike_shop_action['is_done'] && (!isset($ev_bike_shop_actions_todo[$ev_bike_shop_action['id']]) || !$ev_bike_shop_actions_todo[$ev_bike_shop_action['id']])) {
                        $ev_bike_shop_act_count++;
                    }
                    $ev_bike_shop_recommended_actions[] = $ev_bike_shop_action;
                    $ev_bike_shop_actions_todo[]        = array('id' => $ev_bike_shop_action['id'], 'watch' => true);
                }
                return array('count' => $ev_bike_shop_act_count, 'actions' => $ev_bike_shop_recommended_actions);
            }

        }

        public function ev_bike_shop_get_recommended_plugins() {

            $ev_bike_shop_plugins = apply_filters('ev_bike_shop_recommended_plugins', array());
            return $ev_bike_shop_plugins;
        }

        public function ev_bike_shop_get_plugin_buttion($slug, $name, $function) {
                $ev_bike_shop_is_done      = false;
                $ev_bike_shop_button_html  = '';
                $ev_bike_shop_is_installed = $this->is_plugin_installed($slug);
                $ev_bike_shop_plugin_path  = $this->get_plugin_basename_from_slug($slug);
                $ev_bike_shop_is_activeted = (class_exists($function)) ? true : false;
                if (!$ev_bike_shop_is_installed) {
                    $ev_bike_shop_plugin_install_url = add_query_arg(
                        array(
                            'action' => 'install-plugin',
                            'plugin' => $slug,
                        ),
                        self_admin_url('update.php')
                    );
                    $ev_bike_shop_plugin_install_url = wp_nonce_url($ev_bike_shop_plugin_install_url, 'install-plugin_' . esc_attr($slug));
                    $ev_bike_shop_button_html        = sprintf('<a class="ev-bike-shop-plugin-install install-now button-secondary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($ev_bike_shop_plugin_install_url),
                        sprintf(esc_html__('Install %s Now', 'ev-bike-shop'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Install & Activate', 'ev-bike-shop')
                    );
                } elseif ($ev_bike_shop_is_installed && !$ev_bike_shop_is_activeted) {

                    $ev_bike_shop_plugin_activate_link = add_query_arg(
                        array(
                            'action'        => 'activate',
                            'plugin'        => rawurlencode($ev_bike_shop_plugin_path),
                            'plugin_status' => 'all',
                            'paged'         => '1',
                            '_wpnonce'      => wp_create_nonce('activate-plugin_' . $ev_bike_shop_plugin_path),
                        ), self_admin_url('plugins.php')
                    );

                    $ev_bike_shop_button_html = sprintf('<a class="ev-bike-shop-plugin-activate activate-now button-primary button" data-slug="%1$s" href="%2$s" aria-label="%3$s" data-name="%4$s">%5$s</a>',
                        esc_attr($slug),
                        esc_url($ev_bike_shop_plugin_activate_link),
                        sprintf(esc_html__('Activate %s Now', 'ev-bike-shop'), esc_html($name)),
                        esc_html($name),
                        esc_html__('Activate', 'ev-bike-shop')
                    );
                } elseif ($ev_bike_shop_is_activeted) {
                    $ev_bike_shop_button_html = sprintf('<div class="action-link button disabled"><span class="dashicons dashicons-yes"></span> %s</div>', esc_html__('Active', 'ev-bike-shop'));
                    $ev_bike_shop_is_done     = true;
                }

                return array('done' => $ev_bike_shop_is_done, 'button' => $ev_bike_shop_button_html);
            }
        public function is_plugin_installed($slug) {
            $ev_bike_shop_installed_plugins = $this->get_installed_plugins(); // Retrieve a list of all installed plugins (WP cached).
            $ev_bike_shop_file_path         = $this->get_plugin_basename_from_slug($slug);
            return (!empty($ev_bike_shop_installed_plugins[$ev_bike_shop_file_path]));
        }
        public function get_plugin_basename_from_slug($slug) {
            $ev_bike_shop_keys = array_keys($this->get_installed_plugins());
            foreach ($ev_bike_shop_keys as $ev_bike_shop_key) {
                if (preg_match('|^' . $slug . '/|', $ev_bike_shop_key)) {
                    return $ev_bike_shop_key;
                }
            }
            return $slug;
        }

        public function get_installed_plugins() {

            if (!function_exists('get_plugins')) {
                require_once ABSPATH . 'wp-admin/includes/plugin.php';
            }

            return get_plugins();
        }
        public function create_pattern_setup_builder() {

            $edit_page = admin_url().'post-new.php?post_type=page&create_pattern=true';
            echo json_encode(['page_id'=>'','edit_page_url'=> $edit_page ]);

            exit;
        }

    }
}
/**
 * Kicking this off by calling 'get_instance()' method
 */
EV_Bike_Shop_Plugin_Activation_WPElemento_Importer::get_instance();